# -*- R -*-

f = "../data/data.csv"

msg = function(...) { cat(sprintf(...), sep = "\n") }

geo.mean = function(v) {
    prod(v ** (1/length(v)))
}

data = read.table(f, header = TRUE, sep = ",", na.strings = ".")

for (all in c(FALSE, TRUE)) {
    msg("")
    msg("~~~~~%s~~~~~", ifelse(all, "Both Target conditions", "Direct estimators only"))
    msg("")

    d1 = data.matrix(data[(all | data["Target"] == 1) & data["Strategy"] == 1, c(5, 6, 7, 8, 9)])
    d2 = data.matrix(data[(all | data["Target"] == 1) & data["Strategy"] == 2, c(5, 6, 7, 8, 9)])

    correct = c(3540940, 451000000000, 7114955, 3900, 76200000)

    msg("      Geometric mean")
    msg("Q Intuitive   Deliberative   Correct answer")

    for (n in c(1, 2, 3, 4, 5)) {
        msg("%.0f %9.0f%15.0f%17.0f",
            n,
            round(geo.mean(na.omit(d1[,n]))),
            round(geo.mean(na.omit(d2[,n]))),
            correct[n])
    }

    msg("\nQ Range Int   Range Del   IQR Int   IQR Del")

    for (n in c(1, 2, 3, 4, 5)) {
        msg("%.0f %9.2f%12.2f%10.2f%10.2f",
            n,
            log(max(na.omit(d1[,n])) / min(na.omit(d1[,n]))),
            log(max(na.omit(d2[,n])) / min(na.omit(d2[,n]))),
            log(quantile(d1[,n], .75, na.rm = TRUE) / quantile(d1[,n], .25, na.rm = TRUE)),
            log(quantile(d2[,n], .75, na.rm = TRUE) / quantile(d2[,n], .25, na.rm = TRUE)))
    }

}
